#include <bits/stdc++.h>
using namespace std;

int MAXN = 40;
int MAXM = 40;

int L = 8*MAXN*MAXM;
vector<vector<int>> graph (L);
vector<int> matchL (L, -1);
vector<int> matchR (L, -1);
vector<bool> visited(L);

int dfs(int u) {
  if (visited[u]) { return 0; }
  visited[u] = true;

  for (int v : graph[u]) {
    if (matchR[v] == -1 || dfs(matchR[v])) {
      matchR[v] = u;
      matchL[u] = v;
      return 1;
    }
  }

  return 0;
}

int kuhn(int n) {
  int ans = 0;
  for (int u = 0; u < n; u++) {
    fill(visited.begin(), visited.end(), false);
    ans += dfs(u);
  }
  return ans;
}

typedef struct {
    char digit = 0;
    bool orange;
} square;

#define LEFT 0
#define RIGHT 1
#define UP 2
#define DOWN 3

int main() {
    cin.tie(0);
    ios_base::sync_with_stdio(0);

    int n, m;
    cin >> n >> m;

    vector<vector<square>> grid (n, vector<square>(m));
    vector<vector<int>> by_row (n);
    vector<vector<int>> by_column (m);

    int orange_digit_count = 0;
    int blue_digit_count = 0;

    for (int i = 0; i < n; i++) {
    for (int j = 0; j < m; j++) {
        char c1, c2;
        cin >> c1 >> c2;

        if (c1 == '.') { continue; }

        by_row[i].push_back(j);
        by_column[j].push_back(i);
        grid[i][j] = {
            .digit = char(c1 - '0'),
            .orange = bool(c2 - 'a')
        };
        if (grid[i][j].orange) {
            orange_digit_count += grid[i][j].digit;
        } else {
            blue_digit_count += grid[i][j].digit;
        }
    }
    }

    if (orange_digit_count != blue_digit_count) {
        cout << "NO\n";
        return 0;
    }

    vector<vector<char>> nodes (n, vector<char>(m));

    for (int i = 0; i < n; i++) {
    for (int k = 1; k < by_row[i].size(); k++) {
        int lj = by_row[i][k-1];
        int j = by_row[i][k];

        if (grid[i][lj].orange != grid[i][j].orange) {
            int u = 8*(MAXN*i+lj)+2*RIGHT;
            int v = 8*(MAXN*i+j)+2*LEFT;
            if (!grid[i][j].orange) { swap(u, v); }
            graph[u].push_back(v);
            graph[u+1].push_back(v+1);
            nodes[i][lj] |= 1<<RIGHT;
            nodes[i][j] |= 1<<LEFT;
        }
    }
    }

    for (int j = 0; j < m; j++) {
    for (int k = 1; k < by_column[j].size(); k++) {
        int li = by_column[j][k-1];
        int i = by_column[j][k];

        if (grid[li][j].orange != grid[i][j].orange) {
            int u = 8*(MAXN*li+j)+2*DOWN;
            int v = 8*(MAXN*i+j)+2*UP;
            if (!grid[i][j].orange) { swap(u, v); }
            graph[u].push_back(v);
            graph[u+1].push_back(v+1);
            nodes[li][j] |= 1<<DOWN;
            nodes[i][j] |= 1<<UP;
        }
    }
    }

    for (int i = 0; i < n; i++) {
    for (int j = 0; j < m; j++) {
        int diff = (2*__builtin_popcount(nodes[i][j]) - grid[i][j].digit);
        if (diff < 0) { cout << "NO\n"; return 0; }
        for (int k = 0; k < diff; k++) {
            for (int d = 0; d < 4; d++) if (nodes[i][j] & (1<<d)) {
                int u = 8*(MAXN*i+j)+k;
                int v = 8*(MAXN*i+j)+2*d;
                if (!grid[i][j].orange) {
                    graph[v].push_back(u);
                    graph[v+1].push_back(u);
                } else {
                    graph[u].push_back(v);
                    graph[u].push_back(v+1);
                }
            }
        }
    }
    }

    int v = 0;
    for (int u = 0; u < graph.size(); u++) if (graph[u].size()) {
        v++;
    }

    cout << (kuhn(8*MAXN*MAXM) == v ? "YES\n" : "NO\n");
}
